diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.h ns-3.44/src/wifi/model/he/rr-multi-user-scheduler.h
--- ns-3.43/src/wifi/model/he/rr-multi-user-scheduler.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/he/rr-multi-user-scheduler.h	2025-03-09 16:55:49.791372500 -0700
@@ -18,7 +18,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * RrMultiUserScheduler is a simple OFDMA scheduler that indicates to perform a DL OFDMA
  * transmission if the AP has frames to transmit to at least one station.
@@ -28,24 +28,33 @@
  * configurable. Associated stations are served based on their priority. The priority is
  * determined by the credits/debits a station gets when it is selected or not for transmission.
  *
- * \todo Take the supported channel width of the stations into account while selecting
+ * @todo Take the supported channel width of the stations into account while selecting
  * stations and assigning RUs to them.
  */
 class RrMultiUserScheduler : public MultiUserScheduler
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     RrMultiUserScheduler();
     ~RrMultiUserScheduler() override;
 
+    Time GetExtraTimeForBsrpTfDurationId(uint8_t linkId) const override;
+
   protected:
     void DoDispose() override;
     void DoInitialize() override;
 
+    void UpdateTriggerFrameAfterProtection(uint8_t linkId,
+                                           CtrlTriggerHeader& trigger,
+                                           WifiTxParameters& txParams) const override;
+    void UpdateDlMuAfterProtection(uint8_t linkId,
+                                   WifiPsduMap& psduMap,
+                                   WifiTxParameters& txParams) const override;
+
     /**
      * Information used to sort stations
      */
@@ -59,16 +68,16 @@
     /**
      * Determine whether the given STA can be solicited via a Basic Trigger Frame.
      *
-     * \param info the information about the given STA
-     * \return whether the given STA can be solicited via a Basic Trigger Frame
+     * @param info the information about the given STA
+     * @return whether the given STA can be solicited via a Basic Trigger Frame
      */
     virtual bool CanSolicitStaInBasicTf(const MasterInfo& info) const;
 
     /**
      * Determine whether the given STA can be solicited via a BSRP Trigger Frame.
      *
-     * \param info the information about the given STA
-     * \return whether the given STA can be solicited via a BSRP Trigger Frame
+     * @param info the information about the given STA
+     * @return whether the given STA can be solicited via a BSRP Trigger Frame
      */
     virtual bool CanSolicitStaInBsrpTf(const MasterInfo& info) const;
 
@@ -81,7 +90,7 @@
      * Check if it is possible to send a BSRP Trigger Frame given the current
      * time limits.
      *
-     * \return UL_MU_TX if it is possible to send a BSRP TF, NO_TX otherwise
+     * @return UL_MU_TX if it is possible to send a BSRP TF, NO_TX otherwise
      */
     virtual TxFormat TrySendingBsrpTf();
 
@@ -89,7 +98,7 @@
      * Check if it is possible to send a Basic Trigger Frame given the current
      * time limits.
      *
-     * \return UL_MU_TX if it is possible to send a Basic TF, DL_MU_TX if we can try
+     * @return UL_MU_TX if it is possible to send a Basic TF, DL_MU_TX if we can try
      *         to send a DL MU PPDU and NO_TX if the remaining time is too short
      */
     virtual TxFormat TrySendingBasicTf();
@@ -98,7 +107,7 @@
      * Check if it is possible to send a DL MU PPDU given the current
      * time limits.
      *
-     * \return DL_MU_TX if it is possible to send a DL MU PPDU, SU_TX if a SU PPDU
+     * @return DL_MU_TX if it is possible to send a DL MU PPDU, SU_TX if a SU PPDU
      *         can be transmitted (e.g., there are no HE stations associated or sending
      *         a DL MU PPDU is not possible and m_forceDlOfdma is false) or NO_TX otherwise
      */
@@ -109,8 +118,8 @@
      * transmissions from suitable stations, i.e., stations that have established a
      * BlockAck agreement with the AP and for which the given predicate returns true.
      *
-     * \param canBeSolicited a predicate returning false for stations that shall not be solicited
-     * \return a TXVECTOR that can be used to construct a Trigger Frame to solicit
+     * @param canBeSolicited a predicate returning false for stations that shall not be solicited
+     * @return a TXVECTOR that can be used to construct a Trigger Frame to solicit
      *         transmissions from suitable stations
      */
     virtual WifiTxVector GetTxVectorForUlMu(std::function<bool(const MasterInfo&)> canBeSolicited);
@@ -118,15 +127,15 @@
     /**
      * Notify the scheduler that a station associated with the AP
      *
-     * \param aid the AID of the station
-     * \param address the MAC address of the station
+     * @param aid the AID of the station
+     * @param address the MAC address of the station
      */
     void NotifyStationAssociated(uint16_t aid, Mac48Address address);
     /**
      * Notify the scheduler that a station deassociated with the AP
      *
-     * \param aid the AID of the station
-     * \param address the MAC address of the station
+     * @param aid the AID of the station
+     * @param address the MAC address of the station
      */
     void NotifyStationDeassociated(uint16_t aid, Mac48Address address);
 
@@ -139,16 +148,16 @@
      * TXVECTOR contains a subset of such HeMuUserInfo entries. The set of candidate
      * stations is also updated by removing stations that are not allocated an RU.
      *
-     * \param txVector the given TXVECTOR
+     * @param txVector the given TXVECTOR
      */
     void FinalizeTxVector(WifiTxVector& txVector);
     /**
      * Update credits of the stations in the given list considering that a PPDU having
      * the given duration is being transmitted or solicited by using the given TXVECTOR.
      *
-     * \param staList the list of stations
-     * \param txDuration the TX duration of the PPDU being transmitted or solicited
-     * \param txVector the TXVECTOR for the PPDU being transmitted or solicited
+     * @param staList the list of stations
+     * @param txDuration the TX duration of the PPDU being transmitted or solicited
+     * @param txVector the TXVECTOR for the PPDU being transmitted or solicited
      */
     void UpdateCredits(std::list<MasterInfo>& staList,
                        Time txDuration,
@@ -173,6 +182,7 @@
     Time m_maxCredits;                     //!< Max amount of credits a station can have
     CtrlTriggerHeader m_trigger;           //!< Trigger Frame to send
     WifiMacHeader m_triggerMacHdr;         //!< MAC header for Trigger Frame
+    Time m_triggerTxDuration{0};           //!< Trigger Frame TX duration
     WifiTxParameters m_txParams;           //!< TX parameters
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/ht/ht-capabilities.h ns-3.44/src/wifi/model/ht/ht-capabilities.h
--- ns-3.43/src/wifi/model/ht/ht-capabilities.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/ht/ht-capabilities.h	2025-03-09 16:55:49.791372500 -0700
@@ -22,8 +22,8 @@
 {
 
 /**
- * \brief The HT Capabilities Information Element
- * \ingroup wifi
+ * @brief The HT Capabilities Information Element
+ * @ingroup wifi
  *
  * This class knows how to serialise and deserialise the HT Capabilities Information Element
  */
@@ -38,35 +38,35 @@
     /**
      * Set the HT Capabilities Info field in the HT Capabilities information element.
      *
-     * \param ctrl the HT Capabilities Info field in the HT Capabilities information element
+     * @param ctrl the HT Capabilities Info field in the HT Capabilities information element
      */
     void SetHtCapabilitiesInfo(uint16_t ctrl);
     /**
      * Set the A-MPDU Parameters field in the HT Capabilities information element.
      *
-     * \param ctrl the A-MPDU Parameters field in the HT Capabilities information element
+     * @param ctrl the A-MPDU Parameters field in the HT Capabilities information element
      */
     void SetAmpduParameters(uint8_t ctrl);
     /**
      * Set the Supported MCS Set field in the HT Capabilities information element.
      *
-     * \param ctrl1 the first 64 bytes of the Supported MCS Set field in the HT Capabilities
+     * @param ctrl1 the first 64 bytes of the Supported MCS Set field in the HT Capabilities
      * information element
-     * \param ctrl2 the last 64 bytes of the Supported MCS Set field in the HT Capabilities
+     * @param ctrl2 the last 64 bytes of the Supported MCS Set field in the HT Capabilities
      * information element
      */
     void SetSupportedMcsSet(uint64_t ctrl1, uint64_t ctrl2);
     /**
      * Set the Extended HT Capabilities field in the HT Capabilities information element.
      *
-     * \param ctrl the Extended HT Capabilities field in the HT Capabilities information element
+     * @param ctrl the Extended HT Capabilities field in the HT Capabilities information element
      */
     void SetExtendedHtCapabilities(uint16_t ctrl);
     /**
      * Set the Transmit Beamforming (TxBF) Capabilities field in the HT Capabilities information
      * element.
      *
-     * \param ctrl the Transmit Beamforming (TxBF) Capabilities field in the HT Capabilities
+     * @param ctrl the Transmit Beamforming (TxBF) Capabilities field in the HT Capabilities
      * information element
      */
     void SetTxBfCapabilities(uint32_t ctrl);
@@ -74,7 +74,7 @@
      * Set the the Antenna Selection (ASEL) Capabilities field in the HT Capabilities information
      * element.
      *
-     * \param ctrl the Antenna Selection (ASEL) Capabilities field in the HT Capabilities
+     * @param ctrl the Antenna Selection (ASEL) Capabilities field in the HT Capabilities
      * information element
      */
     void SetAntennaSelectionCapabilities(uint8_t ctrl);
@@ -82,101 +82,101 @@
     /**
      * Set the LDPC field.
      *
-     * \param ldpc the LDPC field
+     * @param ldpc the LDPC field
      */
     void SetLdpc(uint8_t ldpc);
     /**
      * Set the supported channel width field.
      *
-     * \param supportedChannelWidth the supported channel width field
+     * @param supportedChannelWidth the supported channel width field
      */
     void SetSupportedChannelWidth(uint8_t supportedChannelWidth);
     /**
      * Set the short guard interval 20 field.
      *
-     * \param shortGuardInterval the short guard interval
+     * @param shortGuardInterval the short guard interval
      */
     void SetShortGuardInterval20(uint8_t shortGuardInterval);
     /**
      * Set the short guard interval 40 field.
      *
-     * \param shortGuardInterval the short guard interval
+     * @param shortGuardInterval the short guard interval
      */
     void SetShortGuardInterval40(uint8_t shortGuardInterval);
     /**
      * Set the maximum AMSDU length.
      *
-     * \param maxAmsduLength Either 3839 or 7935
+     * @param maxAmsduLength Either 3839 or 7935
      */
     void SetMaxAmsduLength(uint16_t maxAmsduLength);
     /**
      * Set the LSIG protection support.
      *
-     * \param lSigProtection the LSIG protection support field
+     * @param lSigProtection the LSIG protection support field
      */
     void SetLSigProtectionSupport(uint8_t lSigProtection);
 
     /**
      * Set the maximum AMPDU length.
      *
-     * \param maxAmpduLength 2^(13 + x) - 1, x in the range 0 to 3
+     * @param maxAmpduLength 2^(13 + x) - 1, x in the range 0 to 3
      */
     void SetMaxAmpduLength(uint32_t maxAmpduLength);
 
     /**
      * Set the receive MCS bitmask.
      *
-     * \param index the index of the receive MCS
+     * @param index the index of the receive MCS
      */
     void SetRxMcsBitmask(uint8_t index);
     /**
      * Set the receive highest supported data rate.
      *
-     * \param maxSupportedRate the maximum supported data rate
+     * @param maxSupportedRate the maximum supported data rate
      */
     void SetRxHighestSupportedDataRate(uint16_t maxSupportedRate);
     /**
      * Set the transmit MCS set defined.
      *
-     * \param txMcsSetDefined the TX MCS set defined
+     * @param txMcsSetDefined the TX MCS set defined
      */
     void SetTxMcsSetDefined(uint8_t txMcsSetDefined);
     /**
      * Set the transmit / receive MCS set unequal.
      *
-     * \param txRxMcsSetUnequal the TX/RX MCS set unequal field
+     * @param txRxMcsSetUnequal the TX/RX MCS set unequal field
      */
     void SetTxRxMcsSetUnequal(uint8_t txRxMcsSetUnequal);
     /**
      * Set the transmit maximum N spatial streams.
      *
-     * \param maxTxSpatialStreams the maximum number of TX SSs
+     * @param maxTxSpatialStreams the maximum number of TX SSs
      */
     void SetTxMaxNSpatialStreams(uint8_t maxTxSpatialStreams);
     /**
      * Set the transmit unequal modulation.
      *
-     * \param txUnequalModulation the TX unequal modulation field
+     * @param txUnequalModulation the TX unequal modulation field
      */
     void SetTxUnequalModulation(uint8_t txUnequalModulation);
 
     /**
      * Return the HT Capabilities Info field in the HT Capabilities information element.
      *
-     * \return the HT Capabilities Info field in the HT Capabilities information element
+     * @return the HT Capabilities Info field in the HT Capabilities information element
      */
     uint16_t GetHtCapabilitiesInfo() const;
     /**
      * Return the A-MPDU Parameters field in the HT Capabilities information element.
      *
-     * \return the A-MPDU Parameters field in the HT Capabilities information element
+     * @return the A-MPDU Parameters field in the HT Capabilities information element
      */
     uint8_t GetAmpduParameters() const;
     /**
      * Return the first 64 bytes of the Supported MCS Set field in the HT Capabilities information
      * element.
      *
-     * \return the first 64 bytes of the Supported MCS Set field in the HT Capabilities information
+     * @return the first 64 bytes of the Supported MCS Set field in the HT Capabilities information
      * element
      */
     uint64_t GetSupportedMcsSet1() const;
@@ -184,21 +184,21 @@
      * Return the last 64 bytes of the Supported MCS Set field in the HT Capabilities information
      * element.
      *
-     * \return the last 64 bytes of the Supported MCS Set field in the HT Capabilities information
+     * @return the last 64 bytes of the Supported MCS Set field in the HT Capabilities information
      * element
      */
     uint64_t GetSupportedMcsSet2() const;
     /**
      * Return the Extended HT Capabilities field in the HT Capabilities information element.
      *
-     * \return the Extended HT Capabilities field in the HT Capabilities information element
+     * @return the Extended HT Capabilities field in the HT Capabilities information element
      */
     uint16_t GetExtendedHtCapabilities() const;
     /**
      * Return the Transmit Beamforming (TxBF) Capabilities field in the HT Capabilities information
      * element.
      *
-     * \return the Transmit Beamforming (TxBF) Capabilities field in the HT Capabilities information
+     * @return the Transmit Beamforming (TxBF) Capabilities field in the HT Capabilities information
      * element
      */
     uint32_t GetTxBfCapabilities() const;
@@ -206,7 +206,7 @@
      * Return the Antenna Selection (ASEL) Capabilities field in the HT Capabilities information
      * element.
      *
-     * \return the Antenna Selection (ASEL) Capabilities field in the HT Capabilities information
+     * @return the Antenna Selection (ASEL) Capabilities field in the HT Capabilities information
      * element
      */
     uint8_t GetAntennaSelectionCapabilities() const;
@@ -214,45 +214,45 @@
     /**
      * Return LDPC.
      *
-     * \return the LDPC value
+     * @return the LDPC value
      */
     uint8_t GetLdpc() const;
     /**
      * Return the supported channel width.
      *
-     * \return the supported channel width
+     * @return the supported channel width
      */
     uint8_t GetSupportedChannelWidth() const;
     /**
      * Return the short guard interval 20 value.
      *
-     * \return the short guard interval 20 value
+     * @return the short guard interval 20 value
      */
     uint8_t GetShortGuardInterval20() const;
     /**
      * Return the maximum A-MSDU length.
      *
-     * \return the maximum A-MSDU length
+     * @return the maximum A-MSDU length
      */
     uint16_t GetMaxAmsduLength() const;
     /**
      * Return the maximum A-MPDU length.
      *
-     * \return the maximum A-MPDU length
+     * @return the maximum A-MPDU length
      */
     uint32_t GetMaxAmpduLength() const;
     /**
      * Return the is MCS supported flag.
      *
-     * \param mcs is MCS supported flag
+     * @param mcs is MCS supported flag
      *
-     * \return true if successful
+     * @return true if successful
      */
     bool IsSupportedMcs(uint8_t mcs) const;
     /**
      * Return the receive highest supported antennas.
      *
-     * \return the receive highest supported antennas
+     * @return the receive highest supported antennas
      */
     uint8_t GetRxHighestSupportedAntennas() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/ht/ht-configuration.cc ns-3.44/src/wifi/model/ht/ht-configuration.cc
--- ns-3.43/src/wifi/model/ht/ht-configuration.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/ht/ht-configuration.cc	2025-03-09 16:55:49.791372500 -0700
@@ -40,20 +40,17 @@
             .AddAttribute("ShortGuardIntervalSupported",
                           "Whether or not short guard interval is supported.",
                           BooleanValue(false),
-                          MakeBooleanAccessor(&HtConfiguration::GetShortGuardIntervalSupported,
-                                              &HtConfiguration::SetShortGuardIntervalSupported),
+                          MakeBooleanAccessor(&HtConfiguration::m_sgiSupported),
                           MakeBooleanChecker())
             .AddAttribute("LdpcSupported",
                           "Whether or not LDPC coding is supported.",
                           BooleanValue(false),
-                          MakeBooleanAccessor(&HtConfiguration::GetLdpcSupported,
-                                              &HtConfiguration::SetLdpcSupported),
+                          MakeBooleanAccessor(&HtConfiguration::m_ldpcSupported),
                           MakeBooleanChecker())
             .AddAttribute("Support40MHzOperation",
                           "Whether or not 40 MHz operation is to be supported.",
                           BooleanValue(true),
-                          MakeBooleanAccessor(&HtConfiguration::Get40MHzOperationSupported,
-                                              &HtConfiguration::Set40MHzOperationSupported),
+                          MakeBooleanAccessor(&HtConfiguration::m_40MHzSupported),
                           MakeBooleanChecker());
     return tid;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/ht/ht-configuration.h ns-3.44/src/wifi/model/ht/ht-configuration.h
--- ns-3.43/src/wifi/model/ht/ht-configuration.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/ht/ht-configuration.h	2025-03-09 16:55:49.791372500 -0700
@@ -9,14 +9,15 @@
 #ifndef HT_CONFIGURATION_H
 #define HT_CONFIGURATION_H
 
+#include "ns3/deprecated.h"
 #include "ns3/object.h"
 
 namespace ns3
 {
 
 /**
- * \brief HT configuration
- * \ingroup wifi
+ * @brief HT configuration
+ * @ingroup wifi
  *
  * This object stores HT configuration information, for use in modifying
  * AP or STA behavior and for constructing HT-related information elements.
@@ -29,53 +30,63 @@
     ~HtConfiguration() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
      * Enable or disable SGI support.
      *
-     * \param enable true if SGI is to be supported,
+     * @param enable true if SGI is to be supported,
      *               false otherwise
      */
+    NS_DEPRECATED_3_44("Set the m_sgiSupported member variable instead")
     void SetShortGuardIntervalSupported(bool enable);
+
     /**
-     * \return whether the device supports SGI.
+     * @return whether the device supports SGI.
      *
-     * \return true if SGI is supported,
+     * @return true if SGI is supported,
      *         false otherwise.
      */
+    NS_DEPRECATED_3_44("Get the m_sgiSupported member variable instead")
     bool GetShortGuardIntervalSupported() const;
+
     /**
      * Enable or disable LDPC support.
      *
-     * \param enable true if LDPC is to be supported,
+     * @param enable true if LDPC is to be supported,
      *               false otherwise
      */
+    NS_DEPRECATED_3_44("Set the m_ldpcSupported member variable instead")
     void SetLdpcSupported(bool enable);
+
     /**
-     * \return whether the device supports LDPC.
+     * @return whether the device supports LDPC.
      *
-     * \return true if LDPC is supported,
+     * @return true if LDPC is supported,
      *         false otherwise.
      */
+    NS_DEPRECATED_3_44("Get the m_ldpcSupported member variable instead")
     bool GetLdpcSupported() const;
+
     /**
      * Enable or disable 40 MHz operation support.
      *
-     * \param enable true if both 20 MHz and 40 MHz operation is to be supported,
+     * @param enable true if both 20 MHz and 40 MHz operation is to be supported,
      *               false if only 20 MHz operation is to be supported
      */
+    NS_DEPRECATED_3_44("Set the m_40MHzSupported member variable instead")
     void Set40MHzOperationSupported(bool enable);
+
     /**
-     * \return true if both 20 MHz and 40 MHz operation is supported, false if
+     * @return true if both 20 MHz and 40 MHz operation is supported, false if
      *         only 20 MHz operation is supported
      */
+    NS_DEPRECATED_3_44("Get the m_40MHzSupported member variable instead")
     bool Get40MHzOperationSupported() const;
 
-  private:
     bool m_sgiSupported;   ///< flag whether short guard interval is supported
     bool m_ldpcSupported;  ///< flag whether LDPC coding is supported
     bool m_40MHzSupported; ///< whether 40 MHz operation is supported
